#!/usr/bin/perl
use strict;
use warnings;
use Tie::File;
my @array;
my $dep;

if (@ARGV == 0)
{
	print "Usage: perl $0 startup_script [DEPENDENCY]...\n".
	"    Adds dependency(s) to list of services that Should-Start in startup_script\n";
	exit 1;
}

use Fcntl 'O_RDWR';
tie @array, 'Tie::File', $ARGV[0], mode => O_RDWR or die "\"$ARGV[0]\" file not found";

# Shift past the file name to reach first module.
shift;
while (@ARGV > 0)
{
	$dep = $ARGV[0];
	for (@array)
	{
		if (/^(.*Should-Start:)(.*)/i)
		{
			my $tag = $1;
			my $deps = $2;
			if ($deps =~ /\s$dep$/i)
			{
			}
			else
			{
				if ($deps =~ /\s$dep\s/i)
				{
				}
				else
				{
					$deps =~ s/$/ $dep/;
					s/^.*$/$tag$deps/;
				}
			}
		}
	}
	# Shift to get to the next module to be added.
	shift;
}
