#!/usr/bin/perl
use strict;
use warnings;
use Tie::File;
my @array;
my $mod;

if (@ARGV == 0)
{
	print "Usage: perl $0 apache2_config_file [MODULE]...\n".
	"    Adds module(s) to list of APACHE_MODULES in apache2_config_file\n";
	exit 1;
}

use Fcntl 'O_RDWR';
tie @array, 'Tie::File', $ARGV[0], mode => O_RDWR or die "\"$ARGV[0]\" file not found";

# Shift past the file name to reach first module.
shift;
while (@ARGV > 0)
{
	$mod = $ARGV[0];
	for (@array)
	{
		if (/^(\s*APACHE_MODULES)(\s*=\s*)("[^"]*")(\s*.*)/i)
		{
			my $tag = $1;
			my $eq = $2;
			my $mods = $3;
			my $comments = $4;
			if ($mods =~ /["|\s]$mod["|\s]/i)
			{
				$mods =~ s/$mod//;
				s/^.*$/$tag$eq$mods$comments/;
			}
		}
	}
	# Shift to get to the next module to be added.
	shift;
}
