#!/usr/bin/perl -w

# author: Pat Campbell <plc@novell.com>
#         A perl neophyte
#
use warnings;
use strict;
use Tie::File;
my @vhContents;

BEGIN { push( @INC, '/usr/share/YaST2/modules/' ); }
use YaPI::HTTPD;
YaST::YCP::Import ("SCR");
YaST::YCP::Import ("Service");

my $http_server_file = '/var/lib/YaST2/http_server';
my $vglobal_file = "/etc/apache2/ssl-global.conf";

use Fcntl 'O_RDWR';
tie @vhContents, 'Tie::File', $vglobal_file, mode => O_RDWR or die "\"$vglobal_file\" file not found";

#$ENV{'DEBUG'} = '1';

sub dbprint
{
	print STDERR @_ if $ENV{'DEBUG'};
}


findAndReplaceSSLProtocol();

# Method to update the SSL protocols which disables SSLv2, SSLv3 and TLSv1.0
sub findAndReplaceSSLProtocol
{
   my $i;
   my $flag = 0;
 
   for ($i = 0; $i < scalar(@vhContents); $i++)
   {     
      my $SSLProtocolOccurance = index $vhContents[$i], "SSLProtocol all -SSLv2 -SSLv3";
      if ($SSLProtocolOccurance ne -1)
      {
         $flag = 1;
	 
      }
    
      if($flag eq 1)
      {
		 my $SSLProtocolAllOccurance = index $vhContents[$i], "SSLProtocol all";
         my $SSL2VersionOccurance = index $vhContents[$i], "-SSLv2";
         my $SSL3VersionOccurance = index $vhContents[$i], "-SSLv3";
         my $CommentOccurance = index $vhContents[$i], "#";
        

         if ($SSLProtocolAllOccurance ne -1 && $SSL2VersionOccurance ne -1 && $SSL3VersionOccurance ne -1 && ($CommentOccurance eq -1 || $CommentOccurance > 10))
         {
            $vhContents[$i]="#".$vhContents[$i]."\n\n";
            $vhContents[$i].="\tSSLProtocol all -SSLv2 -SSLv3 -TLSv1\n";
			return;
         }
      }
   }
}


# If the wizard has already been run then we only set our required
#  modules.  Will leave it to system admin to get the service started 
#  and the firewall set correctly.  
#  
if ( -e $http_server_file ) 
{
	dbprint "novell-update-apaceh2.pl: Wizard already run, just setting up apache sysconfig\n";
	system( "service apache2 restart");
	exit 0;
}


# Turn on the Apache service
YaPI::HTTPD->ModifyService( 1 );
dbprint "novell-update-apaceh2.pl: HTTPD Service State set to: " . YaPI::HTTPD->ReadService( ) . "\n";

