#!/usr/bin/perl
#
# Comments out base Tomcat5 connector at port 8009 in server.xml.  
# Novell NRM uses that port.
#
use warnings;
use strict;
use Tie::File;

sub dbprint
{
   print STDERR @_ if $ENV{'DEBUG'};
}

my $tomcat5File = "/usr/share/tomcat/conf/server.xml";
my $startTag = "<Connector port=\"8009\"";
my $endTag = "/>";
my $startComment = "    <!-- Commented out, 8009 is used by Novell NRM -->\n    <!--\n";
my $endComment =   "    -->\n";

open tc5Handle, "+<$tomcat5File" or die "Can't open $tomcat5File: $! \n";

my @tc5Contents = <tc5Handle>;
my $str;

for (my $i = 0; $i < scalar(@tc5Contents); $i++)
{
   if ($tc5Contents[$i] =~ /$startComment/)
   {
       dbprint "Already commented out\n";
       close tc5Handle;
       exit 0;
   }
   if ($tc5Contents[$i] =~ /$startTag/)
   {
      dbprint "Found $tc5Contents[$i]\n";
      $str = $tc5Contents[$i];
      $tc5Contents[$i] = $startComment . $str;
      for (my $x = $i; $x < scalar(@tc5Contents); $x++)
      {
	  if ($tc5Contents[$x] =~ /$endTag/)
	  {
	      $str = $tc5Contents[$x];
	      $tc5Contents[$x] = $str . $endComment;
	      last;
	  }
      }
      last;
   }
}

# set the separator to ''
$"='';
#print "@tc5Contents\n";
seek tc5Handle, 0, 0;
truncate tc5handle, 0;
print tc5Handle "@tc5Contents";
close tc5Handle;